package dk.brics.grammar;

/**
 * A nonterminal in a production.
 */
public class NonterminalEntity extends Entity {
	
	/** Nonterminal name. (Not to confuse with the entity label.) */
	private String nonterminal;
	
	/**
	 * Constructs a new nonterminal entity.
	 * @param nonterminal nonterminal
	 * @param label entity label, null if ignorable
	 * @param example example string, null if absent
	 */
	public NonterminalEntity(String nonterminal, String label, String example) throws GrammarException {
		super(label, example);
		this.nonterminal = nonterminal;
	}
	
	/**
	 * Returns string representation of this entity.
	 */
	@Override
	public String toString() {
		return nonterminal;
	}

	/**
	 * Returns the name of this nonterminal entity.
	 * @return nonterminal name
	 */
	public String getNonterminal() {
		return nonterminal;
	}

	@Override
	public <T> T visitBy(EntityVisitor<T> v) {
		return v.visitNonterminalEntity(this);
	}
}
