package dk.brics.grammar;

import static dk.brics.misc.Chars.escape;

/**
 * A string terminal.
 */
public class StringTerminalEntity extends TerminalEntity { // TODO: treat StringTerminalEntity as a RegexpTerminalEntity with singleton automaton?
	
	String string;

	/**
	 * Constructs a new string terminal.
	 * @param string the string
	 */
	public StringTerminalEntity(String string) {
		super(null, null);
		this.string = string;
	}
	
	/**
	 * Returns string representation of this entity.
	 */
	@Override
	public String toString() {
		return "\"" + escape(string) + "\"";
	}
	
	/**
	 * Returns the string of this string terminal.
	 * @return the string
	 */
	public String getString() {
		return string;
	}

	@Override
	public <T> T visitBy(EntityVisitor<T> v) {
		return v.visitStringTerminalEntity(this);
	}
}
