package dk.brics.grammar.ambiguity;

/**
 * Representation of a string with horisontal overlap.
 */
public class HorizontalOverlapString {

	private String s;
	
	private int i1;
	
	private int i2;

	/**
	 * Constructs a new horizontal overlap example string.
	 * @param s string
	 * @param i1 first index
	 * @param i2 second index
	 */
	public HorizontalOverlapString(String s, int i1, int i2) {
		this.s = s;
		this.i1 = i1;
		this.i2 = i2;
	}
	
	/**
	 * Returns the entire string.
	 */
	public String getString() {
		return s;
	}

	/**
	 * Returns the short left substring.
	 */
	public String getX() {
		return s.substring(0, i1);
	}

	/**
	 * Returns the long left substring.
	 */
	public String getXA() {
		return s.substring(0, i2);
	}

	/**
	 * Returns the short right substring.
	 */
	public String getY() {
		return s.substring(i2);
	}

	/**
	 * Returns the long right substring.
	 */
	public String getAY() {
		return s.substring(i1);
	}
}
