package dk.brics.grammar.ast;

/**
 * AST node visitor.
 */
public interface NodeVisitor {
	
	/**
	 * Method to be invoked by {@link AST#traverse} and {@link Node#visitBy(NodeVisitor)} on {@link LeafNode}s.
	 * @param s current node
	 */
	public void visitLeafNode(LeafNode s);

	/**
	 * Method to be invoked by {@link AST#traverse} and {@link Node#visitBy(NodeVisitor)} on {@link BranchNode}s.
	 * @param n current node
	 */
	public void visitBranchNode(BranchNode n);
}
