package dk.brics.grammar.main;

class TimeoutThread extends Thread {

	private boolean cancel = false;

	private boolean done = false;
	
	private Thread current = Thread.currentThread();
	
	private int secs;
	
	TimeoutThread(int secs) {
		this.secs = secs;
		this.start();
	}
	
	@SuppressWarnings("deprecation")
	@Override
	public void run() {
		try {
			sleep(secs * 1000);
			synchronized (this) {
				if (!cancel)
					current.stop(new TimeoutException());
				done = true;
			}
		} catch (InterruptedException e) {
			done = true;
		}
	}
	
	public void cancel() {
		synchronized (this) {
			if (!cancel) {
				cancel = true;
				if (!done)
					interrupt();
			}
		}
	}
}
