package dk.brics.grammar.operations;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Set;

class CharSetNode {
	
	private CharSet cs;
	
	private Collection<CharSetNode> in;
	
	private Collection<CharSetNode> out;
	
	CharSetNode() {
		cs = new CharSet();
		in = new ArrayList<CharSetNode>();
		out = new ArrayList<CharSetNode>();
	}

	CharSet getCS() {
		return cs;
	}
	
	void addIn(CharSetNode n) {
		if (n != null && !in.contains(n) && n != this) {
			in.add(n);
			n.getOut().add(this);
		}
	}

	Collection<CharSetNode> getIn() {
		return in;
	}

	Collection<CharSetNode> getOut() {
		return out;
	}
	
	static void fixpoint(Set<CharSetNode> pending) {
		while (!pending.isEmpty()) {
			CharSetNode f = pending.iterator().next();
			pending.remove(f);
			boolean changed = false;
			for (CharSetNode m : f.getIn())
				changed |= f.getCS().add(m.getCS());
			if (changed) 
				pending.addAll(f.getOut());
		}
	}
}
