package dk.brics.grammar.parser;

import java.io.PrintWriter;

import dk.brics.grammar.Grammar;
import dk.brics.grammar.GrammarException;
import dk.brics.grammar.ast.AST;

/**
 * Converter from grammar files to {@link Grammar}s.
 */
public class String2Grammar {

	/**
	 * Constructs a new converter.
	 */
	public String2Grammar() {}
	
	/**
	 * Constructs grammar object from textual representation.
	 * @param grammar textual representation of grammar
	 * @param file path or URL of grammar (null if unknown)
	 * @param out grammar warnings are printed to this stream if non-null (see {@link AST2Grammar#convert(AST,PrintWriter)}),
	 *            if verbose mode then other messages are also printed here (if null, <code>System.out</code> is used)
	 * @return grammar object
	 * @throws ParseException if grammar is not syntactically correct according to meta.cfg
	 * @throws GrammarException if grammar is invalid for other reasons
	 */
	public Grammar convert(String grammar, String file, PrintWriter out) throws ParseException, GrammarException {
		return new AST2Grammar().convert((new Parser(MetaGrammar.getMetaGrammar(), out)).parse(grammar, file), out);
	}
}
